# coding: utf-8

"""
    Keap REST API

    Keap REST Core Service

    The version of the OpenAPI document: 2.70.0.789938-hf-202503111611
    Contact: api@keap.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from keap_core_v2_client.models.currency_value import CurrencyValue
from typing import Optional, Set
from typing_extensions import Self

class LeadSourceRecurringExpense(BaseModel):
    """
    LeadSourceRecurringExpense
    """ # noqa: E501
    amount: Optional[CurrencyValue] = None
    create_time: Optional[StrictStr] = Field(default=None, description="The time this lead source recurring expense was created")
    end_time: Optional[StrictStr] = Field(default=None, description="The time this lead source recurring expense end")
    id: Optional[StrictStr] = Field(default=None, description="ID of the lead source recurring expense")
    next_expense_time: Optional[StrictStr] = Field(default=None, description="The time this lead source recurring expense will incur a new expense")
    notes: Optional[StrictStr] = Field(default=None, description="The notes for the lead source recurring expense")
    start_time: Optional[StrictStr] = Field(default=None, description="The time this lead source recurring expense starts")
    title: Optional[StrictStr] = Field(default=None, description="The title of the lead source recurring expense")
    update_time: Optional[StrictStr] = Field(default=None, description="The time this lead source recurring expense was last updated")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["amount", "create_time", "end_time", "id", "next_expense_time", "notes", "start_time", "title", "update_time"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LeadSourceRecurringExpense from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of amount
        if self.amount:
            _dict['amount'] = self.amount.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LeadSourceRecurringExpense from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "amount": CurrencyValue.from_dict(obj["amount"]) if obj.get("amount") is not None else None,
            "create_time": obj.get("create_time"),
            "end_time": obj.get("end_time"),
            "id": obj.get("id"),
            "next_expense_time": obj.get("next_expense_time"),
            "notes": obj.get("notes"),
            "start_time": obj.get("start_time"),
            "title": obj.get("title"),
            "update_time": obj.get("update_time")
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


